<?php

use EventPortal\Domain\Event\Form\Models\FormStep;
use EventPortal\Domain\Event\Form\Models\FormStepSection;
use Faker\Generator as Faker;

/** @var \Illuminate\Database\Eloquent\Factory $factory */

$factory->define(FormStepSection::class, static function (Faker $faker): array {
    static $count = 0;
    return [
        'name' => $faker->sentence(3),
        'order' => $count = $count + 1,
        'form_step_id' => static function (): int {
            return factory(FormStep::class)->create()->id;
        },
        'uuid' => $faker->uuid,
    ];
});

$factory->state(FormStepSection::class, 'snapshot', static function (): array {
    return [
        'name' => 'Test Section',
        'order' => 1,
        'form_step_id' => static function (): int {
            return factory(FormStep::class)->state('snapshot')->create()->id;
        },
        'uuid' => 'Test uuid',
    ];
});
