<?php

namespace EventPortal\Domain\Component\Filter;

use EventPortal\Concerns\QueriesJson;
use EventPortal\Domain\Component\Concerns\HasOptions;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Support\Arr;

class MultiSelectDropdownFilter extends Filter
{
    use HasOptions, QueriesJson;

    /** @var string */
    public $type = 'MultiSelect';

    public function __construct(string $label)
    {
        parent::__construct($label);

        $this->lookup(function (Builder $query, $value, $field): Builder {
            return $query->where(function (Builder $query) use ($field, $value): void {
                foreach (Arr::wrap($value) as $value) {
                    $this->whereJson($query, "{$field}->value", $value);
                }
            });
        });
    }
}
