<?php

namespace EventPortal\Domain\Event\Models;

use EventPortal\Domain\Agenda\Models\Session;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\Pivot;

class EventSpeakerSession extends Pivot
{
    public const KEY = 'eventSpeakerSession';

    /** @var string */
    protected $table = 'event_speaker_session';

    /** @var bool */
    public $incrementing = true;

    public function eventSpeaker(): BelongsTo
    {
        return $this->belongsTo(EventSpeaker::class);
    }

    public function sessions(): BelongsTo
    {
        return $this->belongsTo(Session::class);
    }
}
