<?php

namespace EventPortal\Domain\EventDelegate\Handlers;

use Closure;
use EventPortal\Domain\Delegate\Models\DelegateFormStep;
use EventPortal\Domain\Event\Form\Enums\State;
use EventPortal\Domain\Form\Payload;

class UpdatePartialProgress
{
    /**
     * @return mixed
     */
    public function __invoke(Payload $payload, Closure $next)
    {
        $delegate = $payload->getContext('eventDelegate')->delegate;
        $formStep = $payload->getContext('formStep');

        $completeStep = DelegateFormStep::query()
            ->where('delegate_id', $delegate->id)
            ->where('form_step_id', $formStep->id)
            ->where('state', State::Complete())
            ->first();

        if ($completeStep === null) {
            DelegateFormStep::create([
                'state' => State::Partial()->getValue(),
                'delegate_id' => $delegate->id,
                'form_step_id' => $formStep->id,
            ]);
        }

        return $next($payload);
    }
}
