<?php

namespace EventPortal\Domain\Util\Statistics;

class Stat
{
    /** @var string */
    public $label;

    /** @var int */
    public $value;

    /**
     * @var null|string
     */
    public $variant = null;

    /**
     * @param string|int $value
     */
    public function __construct(string $label, $value)
    {
        $this->label = $label;
        $this->value = (int) $value;
    }

    /**
     * @param string|int $value
     */
    public static function make(string $label, $value): self
    {
        return new self($label, $value);
    }

    public function primary(): self
    {
        $this->variant = 'primary';

        return $this;
    }

    public function secondary(): self
    {
        $this->variant = 'secondary';

        return $this;
    }

    public function tertiary(): self
    {
        $this->variant = 'tertiary';

        return $this;
    }

    public function asArray(): array
    {
        return [
            'label' => $this->label,
            'value' => $this->value,
            'variant' => $this->variant,
        ];
    }
}
