<?php

namespace EventPortal\Tests\Unit\Speaker;

use Carbon\Carbon;
use EventPortal\Domain\Speaker\Models\Speaker;
use EventPortal\Tests\TestCase;
use Illuminate\Foundation\Testing\RefreshDatabase;

class SpeakerTest extends TestCase
{
    use RefreshDatabase;

    /** @test **/
    public function exclude_recently_updated_speakers()
    {
        Carbon::setTestNow('29-01-2020 12:00:00');
        $speakerA = factory(Speaker::class)->create();

        Carbon::setTestNow('01-02-2020 15:00:00');
        $speakerB = factory(Speaker::class)->create();

        $speakers = Speaker::withoutRecentlyUpdated()->get();

        $this->assertContainsModel($speakerA, $speakers);
        $this->assertNotContainsModel($speakerB, $speakers);
    }
}
